package cn.ecpark.service.usergw.config;

import java.lang.reflect.Method;
import java.util.function.BiConsumer;
import java.util.function.Function;

import javax.el.MethodNotFoundException;

import org.apache.dubbo.config.ApplicationConfig;
import org.apache.dubbo.config.ReferenceConfig;
import org.apache.dubbo.config.RegistryConfig;
import org.apache.dubbo.rpc.service.GenericService;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import cn.ecpark.service.usergw.biz.filters.bean.GenericServicePool;
import cn.ecpark.service.usergw.biz.filters.factory.DubboGatewayFilterFactory;
import cn.ecpark.service.usergw.utils.Convert;
import lombok.extern.slf4j.Slf4j;

/**
 * ConfigSpecialFunction
 */
@Slf4j
public class ConfigSpecialFunction {



    // public static BiConsumer<ReferenceConfig<GenericService>, String>
    // setApplication = (ref, cfgValue) -> {
    // ref.setApplication(new ApplicationConfig(cfgValue));
    // };

    public static void setApplication(ReferenceConfig<GenericService> ref, Object cfgValue) {
        ref.setApplication(new ApplicationConfig((String)cfgValue));
    }

    public static void setRegistry(ReferenceConfig<GenericService> ref, Object cfgValue) {
        ref.setRegistry(new RegistryConfig((String)cfgValue));
    }

    public static void setDefault(ReferenceConfig<GenericService> ref, String methodName, Object cfgValue) throws Exception {
        methodName = "set" + Convert.firstUpperCase(methodName);
        log.info("method:{}, value:{}",methodName,cfgValue);
        Method method = ref.getClass().getMethod(methodName, cfgValue.getClass());
        method.invoke(ref, cfgValue);
    }
}